package org.beangle.rule.model;

import java.util.List;
import java.util.Map;

import org.beangle.commons.collection.ListUtil;
import org.beangle.commons.collection.MapUtil;
import org.beangle.commons.text.Message;
import org.beangle.rule.Context;

public class SimpleContext implements Context {

	private List<Message> errors = ListUtil.newArrayList();

	private List<Message> messages = ListUtil.newArrayList();

	private Map<String, Object> params = MapUtil.newHashMap();

	public void addError(Message message) {
		errors.add(message);
	}

	public void addMessage(Message message) {
		messages.add(message);
	}

	public List<Message> getErrors() {
		return errors;
	}

	public List<Message> getMessages() {
		return messages;
	}

	public Map<String, Object> getParams() {
		return params;
	}
}
